# Generated by Django 5.0.2 on 2024-02-21 10:51

import django.contrib.auth.models
import django.contrib.auth.validators
import django.contrib.postgres.fields
import django.contrib.postgres.fields.hstore
import django.db.models.deletion
import django.utils.timezone
import model_utils.fields
from django.contrib.postgres.operations import HStoreExtension

import nemo.fields
from django.conf import settings
from django.db import migrations, models


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        ('auth', '0012_alter_user_first_name_max_length'),
    ]

    operations = [
        HStoreExtension(),
        migrations.CreateModel(
            name='Role',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('title', models.CharField(db_index=True, help_text='NEMO role', max_length=50, unique=True)),
                ('description', models.TextField(blank=True, help_text='NEMO role description', null=True)),
                ('active', models.BooleanField(db_index=True, default=True, help_text='Nemo role status')),
            ],
            options={
                'verbose_name': 'Role',
                'verbose_name_plural': 'Roles',
                'db_table': 'nemo_role',
            },
        ),
        migrations.CreateModel(
            name='User',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('password', models.CharField(max_length=128, verbose_name='password')),
                ('last_login', models.DateTimeField(blank=True, null=True, verbose_name='last login')),
                ('is_superuser', models.BooleanField(default=False, help_text='Designates that this user has all permissions without explicitly assigning them.', verbose_name='superuser status')),
                ('username', models.CharField(error_messages={'unique': 'A user with that username already exists.'}, help_text='Required. 150 characters or fewer. Letters, digits and @/./+/-/_ only.', max_length=150, unique=True, validators=[django.contrib.auth.validators.UnicodeUsernameValidator()], verbose_name='username')),
                ('first_name', models.CharField(blank=True, max_length=150, verbose_name='first name')),
                ('last_name', models.CharField(blank=True, max_length=150, verbose_name='last name')),
                ('email', models.EmailField(blank=True, max_length=254, verbose_name='email address')),
                ('is_staff', models.BooleanField(default=False, help_text='Designates whether the user can log into this admin site.', verbose_name='staff status')),
                ('is_active', models.BooleanField(default=True, help_text='Designates whether this user should be treated as active. Unselect this instead of deleting accounts.', verbose_name='active')),
                ('date_joined', models.DateTimeField(default=django.utils.timezone.now, verbose_name='date joined')),
                ('groups', models.ManyToManyField(blank=True, help_text='The groups this user belongs to. A user will get all permissions granted to each of their groups.', related_name='user_set', related_query_name='user', to='auth.group', verbose_name='groups')),
                ('user_permissions', models.ManyToManyField(blank=True, help_text='Specific permissions for this user.', related_name='user_set', related_query_name='user', to='auth.permission', verbose_name='user permissions')),
            ],
            options={
                'verbose_name': 'User',
                'verbose_name_plural': 'Users',
                'db_table': 'nemo_user',
            },
            managers=[
                ('objects', django.contrib.auth.models.UserManager()),
            ],
        ),
        migrations.CreateModel(
            name='UserRole',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created', model_utils.fields.AutoCreatedField(default=django.utils.timezone.now, editable=False, verbose_name='created')),
                ('modified', model_utils.fields.AutoLastModifiedField(default=django.utils.timezone.now, editable=False, verbose_name='modified')),
                ('role', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='nemo.role')),
                ('user', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'verbose_name': 'User Role',
                'verbose_name_plural': 'User Roles',
                'db_table': 'nemo_user_role',
            },
        ),
        migrations.AddField(
            model_name='user',
            name='user_roles',
            field=models.ManyToManyField(through='nemo.UserRole', to='nemo.role'),
        ),
        migrations.CreateModel(
            name='WorkloadDocumentChart',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('api_version', models.CharField(help_text='The chart API version (required)', max_length=2)),
                ('name', models.CharField(db_index=True, help_text='The name of the chart (required)', max_length=100)),
                ('version', nemo.fields.SemVer2Field(db_index=True, help_text='A SemVer 2 version string', max_length=32, validators=[nemo.fields.SemVer2Field.validate_semver])),
                ('kube_version', models.CharField(blank=True, help_text='A SemVer range of compatible Kubernetes versions (optional)', max_length=20, null=True)),
                ('description', models.TextField(blank=True, help_text='A single-sentence description of this project (optional)', null=True)),
                ('type', models.CharField(blank=True, help_text='The type of the chart (optional)', max_length=20, null=True)),
                ('keywords', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(max_length=20), blank=True, help_text='A list of keywords about this project (optional)', null=True, size=None)),
                ('home', models.URLField(blank=True, help_text='The URL of this projects home page (optional)', null=True)),
                ('sources', django.contrib.postgres.fields.ArrayField(base_field=models.URLField(), blank=True, help_text='A list of URLs to source code for this project (optional)', null=True, size=None)),
                ('icon', models.URLField(blank=True, help_text='A URL to an SVG or PNG image to be used as an icon (optional)', null=True)),
                ('app_version', models.CharField(blank=True, help_text="The version of the app that this contains (optional). Needn't be SemVer. Quotes recommended.", max_length=20, null=True)),
                ('deprecated', models.BooleanField(blank=True, help_text='Whether this chart is deprecated (optional, boolean)', null=True)),
                ('annotations', django.contrib.postgres.fields.hstore.HStoreField(blank=True, help_text='A list of annotations keyed by name (optional)', null=True)),
            ],
            options={
                'verbose_name': 'Workload Document Chart',
                'verbose_name_plural': 'Workload Document Charts',
                'db_table': 'workload_document_chart',
                'unique_together': {('name', 'version')},
            },
        ),
        migrations.CreateModel(
            name='WorkloadDocumentChartDependency',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(help_text='The name of the chart', max_length=100)),
                ('version', nemo.fields.SemVer2Field(help_text='A SemVer 2 version string', max_length=32, validators=[nemo.fields.SemVer2Field.validate_semver])),
                ('repository', models.CharField(blank=True, help_text='The repository URL or alias ("repo-name") (optional)', max_length=100, null=True)),
                ('condition', models.CharField(blank=True, help_text='A yaml path that resolves to a boolean, used for enabling/disabling charts (e.g. subchart1.enabled) (optional)', max_length=50, null=True)),
                ('tags', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(max_length=20), blank=True, help_text='Tags can be used to group charts for enabling/disabling together', null=True, size=None)),
                ('import_values', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(max_length=100), blank=True, help_text='ImportValues holds the mapping of source values to parent key to be imported.', null=True, size=None)),
                ('alias', models.CharField(blank=True, help_text='Alias to be used for the chart. Useful when you have to add the same chart multiple times', max_length=20, null=True)),
                ('chart', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='dependencies', to='nemo.workloaddocumentchart')),
            ],
            options={
                'verbose_name': 'Workload Document Chart Dependency',
                'verbose_name_plural': 'Workload Document Chart Dependencies',
                'db_table': 'workload_document_chart_dependency',
            },
        ),
        migrations.CreateModel(
            name='WorkloadDocumentChartMaintainer',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(help_text='The maintainers name (required)', max_length=100)),
                ('email', models.EmailField(blank=True, help_text='The maintainers email (optional)', max_length=254, null=True)),
                ('url', models.URLField(blank=True, help_text='A url for the maintainer (optional)', null=True)),
                ('chart', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='maintainers', to='nemo.workloaddocumentchart')),
            ],
            options={
                'verbose_name': 'Workload Document Chart Maintainer',
                'verbose_name_plural': 'Workload Document Chart Maintainers',
                'db_table': 'workload_document_chart_maintainer',
            },
        ),
        migrations.CreateModel(
            name='WorkloadDocumentChartMetadata',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('container_registries', models.JSONField(help_text='The mapped container registries')),
                ('chart_details', models.JSONField(help_text='The mapped chart details')),
                ('manifests', django.contrib.postgres.fields.ArrayField(base_field=models.JSONField(), help_text='The default generated manifests', size=None)),
                ('values', models.JSONField(help_text='The chart default values')),
                ('resource_mappings', models.JSONField(blank=True, help_text='The container resource mappings', null=True)),
                ('memory_requests', models.BigIntegerField(blank=True, help_text='Total memory requests (in bytes)', null=True)),
                ('memory_limits', models.BigIntegerField(blank=True, help_text='Total memory limits (in bytes)', null=True)),
                ('cpu_requests', models.IntegerField(blank=True, help_text='Total CPU requests (in milli cpus', null=True)),
                ('cpu_limits', models.IntegerField(blank=True, help_text='Total CPU limits (in milli cpus)', null=True)),
                ('chart', models.OneToOneField(on_delete=django.db.models.deletion.CASCADE, related_name='metadata', to='nemo.workloaddocumentchart')),
            ],
            options={
                'verbose_name': 'Workload Document Chart Metadata',
                'verbose_name_plural': 'Workload Document Chart Metadata',
                'db_table': 'workload_document_chart_metadata',
            },
        ),
        migrations.CreateModel(
            name='WorkloadDocument',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created', model_utils.fields.AutoCreatedField(default=django.utils.timezone.now, editable=False, verbose_name='created')),
                ('modified', model_utils.fields.AutoLastModifiedField(default=django.utils.timezone.now, editable=False, verbose_name='modified')),
                ('name', models.CharField(db_index=True, help_text='The workload document name', max_length=100)),
                ('version', nemo.fields.SemVer2Field(db_index=True, help_text='A SemVer 2 version string', max_length=32, validators=[nemo.fields.SemVer2Field.validate_semver])),
                ('schema', models.JSONField(help_text='The document schema')),
                ('type', models.CharField(choices=[('chart', 'Helm Chart')], db_index=True, default='chart', help_text='The workload document type')),
                ('status', models.CharField(choices=[('pending', 'Pending Upload'), ('onboarding', 'Onboarding (running validation evaluation)'), ('accepted', 'Document accepted for usage'), ('rejected', 'Document rejected (e.g. validation failed)')], default='pending', help_text='The workload document status')),
                ('enabled', models.BooleanField(default=True, help_text='If the workload document is enabled')),
                ('rejection_reason', models.TextField(blank=True, help_text='Rejection reason', null=True)),
                ('user', models.ForeignKey(help_text='The NEMO user', on_delete=django.db.models.deletion.CASCADE, related_name='workload_documents', to=settings.AUTH_USER_MODEL)),
                ('chart', models.OneToOneField(blank=True, help_text='The associated helm chart', null=True, on_delete=django.db.models.deletion.CASCADE, related_name='document', to='nemo.workloaddocumentchart')),
            ],
            options={
                'verbose_name': 'Workload Document',
                'verbose_name_plural': 'Workload Documents',
                'db_table': 'workload_document',
                'unique_together': {('name', 'version')},
            },
        ),
    ]
